Subject: Re: fread fails when fopen is used without "rb"
From: [email-masked] (P.J. Kersten)

13 Mar 1998 23:32:31 -0800
Message-ID: <[email-masked]>
References: <[email-masked]>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Transfer-Encoding: 7bit
To: [email-masked]
Cc: [email-masked]

Kevin Cutts wrote:
> 
> I made a mistake and opened a binary file using fopen("file","r"). Note that
> I forgot to open it with "rb". When I read the file, I could only read part
> of the file: the read only suceeded for 2081 bytes of the 345K! Believing
> that I had made a coding mistake, I tried 'wc'. It agreed with my code: they
> both 'think' the file has 2081 bytes. However emacs and ls both realize the
> file is much larger. (When I used a truly ascii file, the size worked
> correctly. The code hack does work correctly under the Metrowerks compiler.)
> 
> Does this seem like the correct behaviour? I can't trust wc because it
> obviously opens as text. I looked in the faq without seeing anything that
> suggests this operation. In this case the failure was the best thing that
> could have happened because I discovered that the legacy unix code needs
> some work around the binary/text problems.
> 
[snip]

Just a guess: byte 2082 is ^D?

HTH,
-- 
Pieter J. Kersten; Erasmus Universiteit Rotterdam, dept. DI&A/S&N,
WH2-10,
B. Oudlaan 50, 3062 PA Rotterdam, The Netherlands; 
Voice: +31-10-4082599; Fax: +31-10-4527236
-
For help on using this list (especially unsubscribing), send a message to
"[email-masked]" with one line of text: "help".